3 # Copyright (c) 2005 Junio C Hamano
6 # Keep the original TERM for say_color
9 # For repeatability, reset the environment to known value.
15 export LANG LC_ALL PAGER TERM TZ
22 unset COMMIT_AUTHOR_EMAIL
23 unset COMMIT_AUTHOR_NAME
25 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
27 GIT_AUTHOR_EMAIL=author@example.com
28 GIT_AUTHOR_NAME='A U Thor'
29 unset GIT_COMMITTER_DATE
30 GIT_COMMITTER_EMAIL=committer@example.com
31 GIT_COMMITTER_NAME='C O Mitter'
35 unset GIT_EXTERNAL_DIFF
37 unset GIT_OBJECT_DIRECTORY
38 unset SHA1_FILE_DIRECTORIES
39 unset SHA1_FILE_DIRECTORY
41 export GIT_MERGE_VERBOSITY
42 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
43 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
46 # Protect ourselves from common misconfiguration to export
47 # CDPATH into the environment
50 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
52 echo "* warning: Some tests will not work if GIT_TRACE" \
53 "is set as to trace on STDERR ! *"
54 echo "* warning: Please set GIT_TRACE to something" \
55 "other than 1, 2 or true ! *"
59 # Each test should start with something like this, after copyright notices:
61 # test_description='Description of this test...
62 # This test checks if command xyzzy does the right thing...
65 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
66 TERM=$ORIGINAL_TERM &&
69 tput bold >/dev/null 2>&1 &&
70 tput setaf 1 >/dev/null 2>&1 &&
71 tput sgr0 >/dev/null 2>&1
78 -d|--d|--de|--deb|--debu|--debug)
80 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
82 -h|--h|--he|--hel|--help)
84 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
86 -q|--q|--qu|--qui|--quie|--quiet)
98 if test -n "$color"; then
104 error) tput bold; tput setaf 1;; # bold red
105 skip) tput bold; tput setaf 2;; # bold green
106 pass) tput setaf 2;; # green
107 info) tput setaf 3;; # brown
108 *) test -n "$quiet" && return;;
117 test -z "$1" && test -n "$quiet" && return
124 say_color error "error: $*"
133 test "${test_description}" != "" ||
134 error "Test script did not set test_description."
136 if test "$help" = "t"
138 echo "$test_description"
143 if test "$verbose" = "t"
147 exec 4>/dev/null 3>/dev/null
156 echo >&5 "FATAL: Unexpected exit with code $?"
163 if test -z "${test_tick+set}"
167 test_tick=$(($test_tick + 60))
169 GIT_COMMITTER_DATE="$test_tick -0700"
170 GIT_AUTHOR_DATE="$test_tick -0700"
171 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
174 # You are not expected to call test_ok_ and test_failure_ directly, use
175 # the text_expect_* functions instead.
178 test_count=$(expr "$test_count" + 1)
179 say_color "" " ok $test_count: $@"
183 test_count=$(expr "$test_count" + 1)
184 test_failure=$(expr "$test_failure" + 1);
185 say_color error "FAIL $test_count: $1"
187 echo "$@" | sed -e 's/^/ /'
188 test "$immediate" = "" || { trap - exit; exit 1; }
191 test_known_broken_ok_ () {
192 test_count=$(expr "$test_count" + 1)
193 test_fixed=$(($test_fixed+1))
194 say_color "" " FIXED $test_count: $@"
197 test_known_broken_failure_ () {
198 test_count=$(expr "$test_count" + 1)
199 test_broken=$(($test_broken+1))
200 say_color skip " still broken $test_count: $@"
204 test "$debug" = "" || eval "$1"
214 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
215 this_test="$this_test.$(expr "$test_count" + 1)"
217 for skp in $GIT_SKIP_TESTS
226 say_color skip >&3 "skipping test: $@"
227 test_count=$(expr "$test_count" + 1)
228 say_color skip "skip $test_count: $1"
237 test_expect_failure () {
239 error "bug in the test script: not 2 parameters to test-expect-failure"
242 say >&3 "checking known breakage: $2"
244 if [ "$?" = 0 -a "$eval_ret" = 0 ]
246 test_known_broken_ok_ "$1"
248 test_known_broken_failure_ "$1"
254 test_expect_success () {
256 error "bug in the test script: not 2 parameters to test-expect-success"
259 say >&3 "expecting success: $2"
261 if [ "$?" = 0 -a "$eval_ret" = 0 ]
271 test_expect_code () {
273 error "bug in the test script: not 3 parameters to test-expect-code"
276 say >&3 "expecting exit code $1: $3"
278 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
288 # This is not among top-level (test_expect_success | test_expect_failure)
289 # but is a prefix that can be used in the test script, like:
291 # test_expect_success 'complain and die' '
293 # do something else &&
294 # test_must_fail git checkout ../outerspace
297 # Writing this as "! git checkout ../outerspace" is wrong, because
298 # the failure could be due to a segv. We want a controlled failure.
302 test $? -gt 0 -a $? -le 128
305 # Most tests can use the created repository, but some may need to create more.
306 # Usage: test_create_repo <directory>
307 test_create_repo () {
309 error "bug in the test script: not 1 parameter to test-create-repo"
313 cd "$repo" || error "Cannot setup test environment"
314 "$GIT_EXEC_PATH/git" init --template=$GIT_EXEC_PATH/templates/blt/ >/dev/null 2>&1 ||
315 error "cannot run git init -- have you built things yet?"
316 mv .git/hooks .git/hooks-disabled
323 if test "$test_fixed" != 0
325 say_color pass "fixed $test_fixed known breakage(s)"
327 if test "$test_broken" != 0
329 say_color error "still have $test_broken known breakage(s)"
330 msg="remaining $(($test_count-$test_broken)) test(s)"
332 msg="$test_count test(s)"
334 case "$test_failure" in
337 # cd .. && rm -fr trash
338 # but that means we forbid any tests that use their own
339 # subdirectory from calling test_done without coming back
340 # to where they started from.
341 # The Makefile provided will clean this test area so
342 # we will leave things as they are.
344 say_color pass "passed all $msg"
348 say_color error "failed $test_failure among $msg"
354 # Test the binaries we have just built. The tests are kept in
355 # t/ subdirectory and are run in trash subdirectory.
357 GIT_EXEC_PATH=$(pwd)/..
358 GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
360 unset GIT_CONFIG_LOCAL
361 GIT_CONFIG_NOSYSTEM=1
362 GIT_CONFIG_NOGLOBAL=1
363 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
365 GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
367 test -d ../templates/blt || {
368 error "You haven't built things yet, have you?"
371 if ! test -x ../test-chmtime; then
372 echo >&2 'You need to build test-chmtime:'
373 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
377 . ../GIT-BUILD-OPTIONS
382 test_create_repo $test
385 this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
386 for skp in $GIT_SKIP_TESTS
389 for skp in $GIT_SKIP_TESTS
398 say_color skip >&3 "skipping test $this_test altogether"
399 say_color skip "skip all tests in $this_test"